#include <Misc.au3>
#include <GuiConstants.au3>
#include <Array.au3>
#include <GuiCombo.au3>
Opt("TrayMenuMode",3)
Opt("GuiOnEventMode",1)
Opt("TrayOnEventMode",1)
Global $ClipInt = 1, $ClipAr, $ClipBkp
Dim $ClipAr[1]
$Main = GUICreate("ClipBoard v1.0 by Mirage",350,500,@DesktopWidth / 2 - 150,@DesktopHeight / 2 - 250)
GUISetOnEvent(-3,"_Exit")
GUISetOnEvent(-4,"_Mini")
GUISetOnEvent(-5,"_Rest")
GUICtrlCreateLabel("Zwischenablagen:",30,25,100,20)
$ComboList = GUICtrlCreateCombo("",30,50,120,20,$CBS_DROPDOWNLIST)
GUICtrlSetOnEvent(-1,"_Switch")
$InsButton = GUICtrlCreateButton("Einfgen",160,50,70,20)
GUICtrlSetState(-1,$GUI_DISABLE)
GUICtrlSetOnEvent(-1,"_InsBut")
$DelButton = GUICtrlCreateButton("Lschen",240,50,70,20)
GUICtrlSetState(-1,$GUI_DISABLE)
GUICtrlSetOnEvent(-1,"_DelBut")
$DelAllButton = GUICtrlCreateButton("Alle Lschen",195,20,80,20)
GUICtrlSetState(-1,$GUI_DISABLE)
GUICtrlSetOnEvent(-1,"_DelAll")
$Menue = GUICtrlCreateMenu("Hilfe")
GUICtrlCreateMenuitem("Info",$Menue)
GUICtrlSetOnEvent(-1,"_Info")
GUICtrlCreateMenuitem("ber ClipBoard",$Menue)
GUICtrlSetOnEvent(-1,"_About")
$EditClip = GUICtrlCreateEdit("",30,90,290,380,BitOR($WS_HSCROLL,$ES_READONLY,$WS_VSCROLL))


$TrayShow = TrayCreateItem("Fenster Anzeigen")
TrayItemSetOnEvent(-1,"_Rest")
;~ TrayItemSetState(-1,128)
$TrayAbout = TrayCreateItem("ber ClipBoard")
TrayItemSetOnEvent(-1,"_About")
$TrayInfo = TrayCreateItem("Info")
TrayItemSetOnEvent(-1,"_Info")
$TrayClose = TrayCreateItem("Beenden")
TrayItemSetOnEvent($TrayClose,"_Exit")
TrayTip("ClipBoard v1.0","ClipBoard gestartet..",2)
Sleep(1000)
TrayTip("","",0)


Func _WfClip()
	If _IsPressed("A2") Then
	Else
		Return
	EndIf
	If _IsPressed("43") Then
		$CGet = ClipGet()
		If @error Then
			Return
		EndIf
	Else
		_KeyMakro()
		Return
	EndIf
	
		If  $CGet = $ClipBkp Then
			TrayTip("ClipBoard v1.0","Die Zwischenablage existiert bereits",3)
			Sleep(3000)
			TrayTip("","",0)
			Return
		EndIf
		If $ClipInt = 63999999 Then
			TrayTip("ClipBoard v1.0","Maximale Auslastung erreicht",3)
			Sleep(3000)
			TrayTip("","",0)
			Return
		EndIf
		$ClipInt = $ClipInt + 1
		ReDim $ClipAr[$ClipInt]
		$ClipAr[$ClipInt - 1] = $CGet
		$ClipBkp = $CGet
		GUICtrlSetData($ComboList,"Ablage Nr."&$ClipInt - 1,"Ablage Nr.1")
		If StringLen($CGet) > 100 Then
			$TrimC = StringTrimRight($CGet,StringLen($CGet) - 100)
			$CGet = $TrimC & " ..."
		EndIf
		TrayTip("ClipBoard v1.0","Zwischenablage Nr."&$ClipInt - 1&" wurde hinzugefgt:"&@CRLF& $CGet,3)
		Sleep(3000)
		TrayTip("","",0)

	If $ClipInt = 2 Then
		GUICtrlSetData($EditClip,$ClipBkp)
		GUICtrlSetState($DelButton,$GUI_ENABLE)
		GUICtrlSetState($DelAllButton,$GUI_ENABLE)
		GUICtrlSetState($InsButton,$GUI_ENABLE)		
	EndIf
EndFunc

Func _Switch()
	$TrimInt = StringTrimLeft(GUICtrlRead($ComboList),10)
	GUICtrlSetData($EditClip,$ClipAr[$TrimInt])
EndFunc

Func _DelBut()
	$TrimInt = StringTrimLeft(GUICtrlRead($ComboList),10)
	$MsgBox = MsgBox(262148,"ClipBoard v1.0","Ablage Nr." & $TrimInt & " lschen?")
	If $MsgBox = 6 Then
		For $i = 0 To _GUICtrlComboGetCount($ComboList)
			_GUICtrlComboDeleteString($ComboList,0)			
		Next
		_ArrayDelete($ClipAr,$TrimInt)
		$ClipInt = $ClipInt - 1	
		For $i = 1 To UBound($ClipAr) - 1
			GUICtrlSetData($ComboList,"Ablage Nr." & $i,"Ablage Nr.1")
		Next
		If UBound($ClipAr) - 1 > 1 Or UBound($ClipAr) - 1 = 1 Then
			GUICtrlSetData($EditClip,$ClipAr[1])
		Else
			GUICtrlSetData($EditClip,"")
			GUICtrlSetState($DelButton,$GUI_DISABLE)
			GUICtrlSetState($DelAllButton,$GUI_DISABLE)
			GUICtrlSetState($InsButton,$GUI_DISABLE)			
		EndIf
	EndIf
EndFunc

Func _DelAll()
	$MsgBox = MsgBox(262148,"ClipBoard v1.0","Alle Ablagen lschen?")
	If $MsgBox = 6 Then
		For $i = 1 To UBound($ClipAr) - 1
			_ArrayDelete($ClipAr,1)
		Next
		For $i = 0 To _GUICtrlComboGetCount($ComboList)
			_GUICtrlComboDeleteString($ComboList,0)
		Next
		GUICtrlSetData($EditClip,"")
		GUICtrlSetData($ComboList,"")
		GUICtrlSetState($DelButton,$GUI_DISABLE)
		GUICtrlSetState($DelAllButton,$GUI_DISABLE)
		GUICtrlSetState($InsButton,$GUI_DISABLE)	
		$ClipInt = 1
	EndIf
EndFunc

Func _InsBut()
	If GUICtrlRead($ComboList) = "" Then
		Return
	EndIf
	ClipPut($ClipAr[StringTrimLeft(GUICtrlRead($ComboList),10)])
EndFunc

Func _KeyMakro()
	Select
	Case _IsPressed("61")
		If UBound($ClipAr) - 1 < 1 Then
			Return
		EndIf
		ClipPut($ClipAr[1])
		TrayTip("ClipBoard v1.0","Ablage Nr.1 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)
	Case _IsPressed("62")
		If UBound($ClipAr) - 1 < 2 Then
			Return
		EndIf
		ClipPut($ClipAr[2])
		TrayTip("ClipBoard v1.0","Ablage Nr.2 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("63")
		If UBound($ClipAr) - 1 < 3 Then
			Return
		EndIf
		ClipPut($ClipAr[3])
		TrayTip("ClipBoard v1.0","Ablage Nr.3 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("64")
		If UBound($ClipAr) - 1 < 4 Then
			Return
		EndIf
		ClipPut($ClipAr[4])
		TrayTip("ClipBoard v1.0","Ablage Nr.4 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("65")
		If UBound($ClipAr) - 1 < 5 Then
			Return
		EndIf
		ClipPut($ClipAr[5])
		TrayTip("ClipBoard v1.0","Ablage Nr.5 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("66")
		If UBound($ClipAr) - 1 < 6 Then
			Return
		EndIf
		ClipPut($ClipAr[6])
		TrayTip("ClipBoard v1.0","Ablage Nr.6 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("67")
		If UBound($ClipAr) - 1 < 7 Then
			Return
		EndIf
		ClipPut($ClipAr[7])
		TrayTip("ClipBoard v1.0","Ablage Nr.7 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("68")
		If UBound($ClipAr) - 1 < 8 Then
			Return
		EndIf
		ClipPut($ClipAr[8])
		TrayTip("ClipBoard v1.0","Ablage Nr.8 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
	Case _IsPressed("69")
		If UBound($ClipAr) - 1 < 9 Then
			Return
		EndIf
		ClipPut($ClipAr[9])
		TrayTip("ClipBoard v1.0","Ablage Nr.9 wurde eingefgt",3)
		Sleep(3000)
		TrayTip("","",0)				
EndSelect
			
EndFunc

Func _Info()
		MsgBox(262144,"ClipBoard v1.0","Anleitung zu ClipBoard v1.0 by Mirage:" & @CRLF & @CRLF & "Um eine Ablage anzufertigen einen markierten Text mit Control/Steuerung und C Abspeichern" & @CRLF & @CRLF & "Wenn sie Dateien oder Ordner Abspeichern wird nur der Zielpfad Abgespeichert" & @CRLF & @CRLF &"Tastenbelegung:" & @CRLF & @CRLF & "Einfgen:   Fgt eine bereits gespeicherte Ablage in die Zwischenablage ein, welche mit Control/Steuerung und v Abrufbar ist." 	& @CRLF & @CRLF & "Lschen:   Lscht die aktuell angezeigte Ablage." & @CRLF & @CRLF & "Alle Lschen:   Lscht alle Ablagen."  & @CRLF & @CRLF & @CRLF & "Nebeninformationen:"  & @CRLF & @CRLF & "Bei der Auflistung der Ablagen werden nur 30 angezeigt, zustzliche knnen mit der Pfeil Unten Taste betrachtet werden."  & @CRLF & @CRLF & @CRLF & "Die Ablagen 1-9 knnen mit Control/Steuerung und Ziffernblock 1-9 eingefgt werden.")
EndFunc	

Func _About()
	MsgBox(262144,"ClipBoard v1.0","Version: 1.0"& @CRLF & @CRLF &"Autor: Mirage"& @CRLF & @CRLF &"Programmiersprache: AutoIt")
EndFunc


Func _Exit()
	$MsgBox = MsgBox(262148,"ClipBoard v1.0","ClipBoard jetzt beenden?")
	If $MsgBox = 6 Then
		Exit
	Else
	EndIf
EndFunc

Func _Mini()
	GUISetState(@SW_HIDE,$Main)
	GUISetState(@SW_DISABLE,$Main)
	TrayItemSetState($TrayShow,64)
EndFunc

Func _Rest()
	GUISetState(@SW_SHOW,$Main)
	GUISetState(@SW_ENABLE,$Main)
	GUISetState(@SW_RESTORE,$Main)
	TrayItemSetState($TrayShow,128)
EndFunc


While 1
_WfClip()
If TrayGetMsg() = $TrayClose Then
	MsgBox(0,"Halo","Buh")
	EndIf
WEnd
